<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="Source of the Rust file `/nix/store/kaan79bbbx80h17lcc5ay919l5r6bqlz-vendored-sources/serde_derive-1.0.140/src/internals/case.rs`."><meta name="keywords" content="rust, rustlang, rust-lang"><title>case.rs - source</title><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../SourceSerif4-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../FiraSans-Regular.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../FiraSans-Medium.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../SourceCodePro-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../SourceSerif4-Bold.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../SourceCodePro-Semibold.ttf.woff2"><link rel="stylesheet" type="text/css" href="../../../normalize.css"><link rel="stylesheet" type="text/css" href="../../../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../../../ayu.css" disabled><link rel="stylesheet" type="text/css" href="../../../dark.css" disabled><link rel="stylesheet" type="text/css" href="../../../light.css" id="themeStyle"><script id="default-settings" ></script><script src="../../../storage.js"></script><script defer src="../../../source-script.js"></script><script defer src="../../../source-files.js"></script><script defer src="../../../main.js"></script><noscript><link rel="stylesheet" href="../../../noscript.css"></noscript><link rel="alternate icon" type="image/png" href="../../../favicon-16x16.png"><link rel="alternate icon" type="image/png" href="../../../favicon-32x32.png"><link rel="icon" type="image/svg+xml" href="../../../favicon.svg"></head><body class="rustdoc source"><!--[if lte IE 11]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="mobile-topbar"><button class="sidebar-menu-toggle">&#9776;</button><a class="sidebar-logo" href="../../../serde_derive/index.html"><div class="logo-container"><img class="rust-logo" src="../../../rust-logo.svg" alt="logo"></div>
        </a><h2 class="location"></h2>
    </nav>
    <nav class="sidebar"><a class="sidebar-logo" href="../../../serde_derive/index.html"><div class="logo-container"><img class="rust-logo" src="../../../rust-logo.svg" alt="logo"></div>
        </a></nav><main><div class="width-limiter"><div class="sub-container"><a class="sub-logo-container" href="../../../serde_derive/index.html"><img class="rust-logo" src="../../../rust-logo.svg" alt="logo"></a><nav class="sub"><form class="search-form"><div class="search-container"><span></span><input class="search-input" name="search" autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"><div id="help-button" title="help" tabindex="-1"><button type="button">?</button></div><div id="settings-menu" tabindex="-1">
                                <a href="../../../settings.html" title="settings"><img width="22" height="22" alt="Change settings" src="../../../wheel.svg"></a></div>
                        </div></form></nav></div><section id="main-content" class="content"><div class="example-wrap"><pre class="line-numbers"><span id="1">1</span>
<span id="2">2</span>
<span id="3">3</span>
<span id="4">4</span>
<span id="5">5</span>
<span id="6">6</span>
<span id="7">7</span>
<span id="8">8</span>
<span id="9">9</span>
<span id="10">10</span>
<span id="11">11</span>
<span id="12">12</span>
<span id="13">13</span>
<span id="14">14</span>
<span id="15">15</span>
<span id="16">16</span>
<span id="17">17</span>
<span id="18">18</span>
<span id="19">19</span>
<span id="20">20</span>
<span id="21">21</span>
<span id="22">22</span>
<span id="23">23</span>
<span id="24">24</span>
<span id="25">25</span>
<span id="26">26</span>
<span id="27">27</span>
<span id="28">28</span>
<span id="29">29</span>
<span id="30">30</span>
<span id="31">31</span>
<span id="32">32</span>
<span id="33">33</span>
<span id="34">34</span>
<span id="35">35</span>
<span id="36">36</span>
<span id="37">37</span>
<span id="38">38</span>
<span id="39">39</span>
<span id="40">40</span>
<span id="41">41</span>
<span id="42">42</span>
<span id="43">43</span>
<span id="44">44</span>
<span id="45">45</span>
<span id="46">46</span>
<span id="47">47</span>
<span id="48">48</span>
<span id="49">49</span>
<span id="50">50</span>
<span id="51">51</span>
<span id="52">52</span>
<span id="53">53</span>
<span id="54">54</span>
<span id="55">55</span>
<span id="56">56</span>
<span id="57">57</span>
<span id="58">58</span>
<span id="59">59</span>
<span id="60">60</span>
<span id="61">61</span>
<span id="62">62</span>
<span id="63">63</span>
<span id="64">64</span>
<span id="65">65</span>
<span id="66">66</span>
<span id="67">67</span>
<span id="68">68</span>
<span id="69">69</span>
<span id="70">70</span>
<span id="71">71</span>
<span id="72">72</span>
<span id="73">73</span>
<span id="74">74</span>
<span id="75">75</span>
<span id="76">76</span>
<span id="77">77</span>
<span id="78">78</span>
<span id="79">79</span>
<span id="80">80</span>
<span id="81">81</span>
<span id="82">82</span>
<span id="83">83</span>
<span id="84">84</span>
<span id="85">85</span>
<span id="86">86</span>
<span id="87">87</span>
<span id="88">88</span>
<span id="89">89</span>
<span id="90">90</span>
<span id="91">91</span>
<span id="92">92</span>
<span id="93">93</span>
<span id="94">94</span>
<span id="95">95</span>
<span id="96">96</span>
<span id="97">97</span>
<span id="98">98</span>
<span id="99">99</span>
<span id="100">100</span>
<span id="101">101</span>
<span id="102">102</span>
<span id="103">103</span>
<span id="104">104</span>
<span id="105">105</span>
<span id="106">106</span>
<span id="107">107</span>
<span id="108">108</span>
<span id="109">109</span>
<span id="110">110</span>
<span id="111">111</span>
<span id="112">112</span>
<span id="113">113</span>
<span id="114">114</span>
<span id="115">115</span>
<span id="116">116</span>
<span id="117">117</span>
<span id="118">118</span>
<span id="119">119</span>
<span id="120">120</span>
<span id="121">121</span>
<span id="122">122</span>
<span id="123">123</span>
<span id="124">124</span>
<span id="125">125</span>
<span id="126">126</span>
<span id="127">127</span>
<span id="128">128</span>
<span id="129">129</span>
<span id="130">130</span>
<span id="131">131</span>
<span id="132">132</span>
<span id="133">133</span>
<span id="134">134</span>
<span id="135">135</span>
<span id="136">136</span>
<span id="137">137</span>
<span id="138">138</span>
<span id="139">139</span>
<span id="140">140</span>
<span id="141">141</span>
<span id="142">142</span>
<span id="143">143</span>
<span id="144">144</span>
<span id="145">145</span>
<span id="146">146</span>
<span id="147">147</span>
<span id="148">148</span>
<span id="149">149</span>
<span id="150">150</span>
<span id="151">151</span>
<span id="152">152</span>
<span id="153">153</span>
<span id="154">154</span>
<span id="155">155</span>
<span id="156">156</span>
<span id="157">157</span>
<span id="158">158</span>
<span id="159">159</span>
<span id="160">160</span>
<span id="161">161</span>
<span id="162">162</span>
<span id="163">163</span>
<span id="164">164</span>
<span id="165">165</span>
<span id="166">166</span>
<span id="167">167</span>
<span id="168">168</span>
<span id="169">169</span>
<span id="170">170</span>
<span id="171">171</span>
<span id="172">172</span>
<span id="173">173</span>
<span id="174">174</span>
<span id="175">175</span>
<span id="176">176</span>
<span id="177">177</span>
<span id="178">178</span>
<span id="179">179</span>
<span id="180">180</span>
<span id="181">181</span>
<span id="182">182</span>
<span id="183">183</span>
<span id="184">184</span>
<span id="185">185</span>
<span id="186">186</span>
<span id="187">187</span>
<span id="188">188</span>
<span id="189">189</span>
<span id="190">190</span>
<span id="191">191</span>
<span id="192">192</span>
<span id="193">193</span>
<span id="194">194</span>
<span id="195">195</span>
<span id="196">196</span>
<span id="197">197</span>
</pre><pre class="rust"><code><span class="doccomment">//! Code to convert the Rust-styled field/variant (e.g. `my_field`, `MyType`) to the</span>
<span class="doccomment">//! case of the source (e.g. `my-field`, `MY_FIELD`).</span>

<span class="comment">// See https://users.rust-lang.org/t/psa-dealing-with-warning-unused-import-std-ascii-asciiext-in-today-s-nightly/13726</span>
<span class="attribute">#[<span class="ident">allow</span>(<span class="ident">deprecated</span>, <span class="ident">unused_imports</span>)]</span>
<span class="kw">use</span> <span class="ident">std::ascii::AsciiExt</span>;

<span class="kw">use</span> <span class="ident">std::fmt</span>::{<span class="self">self</span>, <span class="ident">Debug</span>, <span class="ident">Display</span>};

<span class="kw">use</span> <span class="ident"><span class="self">self</span>::RenameRule</span>::<span class="kw-2">*</span>;

<span class="doccomment">/// The different possible ways to change case of fields in a struct, or variants in an enum.</span>
<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Copy</span>, <span class="ident">Clone</span>, <span class="ident">PartialEq</span>)]</span>
<span class="kw">pub</span> <span class="kw">enum</span> <span class="ident">RenameRule</span> {
    <span class="doccomment">/// Don&#39;t apply a default rename rule.</span>
    <span class="prelude-val">None</span>,
    <span class="doccomment">/// Rename direct children to &quot;lowercase&quot; style.</span>
    <span class="ident">LowerCase</span>,
    <span class="doccomment">/// Rename direct children to &quot;UPPERCASE&quot; style.</span>
    <span class="ident">UpperCase</span>,
    <span class="doccomment">/// Rename direct children to &quot;PascalCase&quot; style, as typically used for</span>
    <span class="doccomment">/// enum variants.</span>
    <span class="ident">PascalCase</span>,
    <span class="doccomment">/// Rename direct children to &quot;camelCase&quot; style.</span>
    <span class="ident">CamelCase</span>,
    <span class="doccomment">/// Rename direct children to &quot;snake_case&quot; style, as commonly used for</span>
    <span class="doccomment">/// fields.</span>
    <span class="ident">SnakeCase</span>,
    <span class="doccomment">/// Rename direct children to &quot;SCREAMING_SNAKE_CASE&quot; style, as commonly</span>
    <span class="doccomment">/// used for constants.</span>
    <span class="ident">ScreamingSnakeCase</span>,
    <span class="doccomment">/// Rename direct children to &quot;kebab-case&quot; style.</span>
    <span class="ident">KebabCase</span>,
    <span class="doccomment">/// Rename direct children to &quot;SCREAMING-KEBAB-CASE&quot; style.</span>
    <span class="ident">ScreamingKebabCase</span>,
}

<span class="kw">static</span> <span class="ident">RENAME_RULES</span>: <span class="kw-2">&amp;</span>[(<span class="kw-2">&amp;</span><span class="ident">str</span>, <span class="ident">RenameRule</span>)] <span class="op">=</span> <span class="kw-2">&amp;</span>[
    (<span class="string">&quot;lowercase&quot;</span>, <span class="ident">LowerCase</span>),
    (<span class="string">&quot;UPPERCASE&quot;</span>, <span class="ident">UpperCase</span>),
    (<span class="string">&quot;PascalCase&quot;</span>, <span class="ident">PascalCase</span>),
    (<span class="string">&quot;camelCase&quot;</span>, <span class="ident">CamelCase</span>),
    (<span class="string">&quot;snake_case&quot;</span>, <span class="ident">SnakeCase</span>),
    (<span class="string">&quot;SCREAMING_SNAKE_CASE&quot;</span>, <span class="ident">ScreamingSnakeCase</span>),
    (<span class="string">&quot;kebab-case&quot;</span>, <span class="ident">KebabCase</span>),
    (<span class="string">&quot;SCREAMING-KEBAB-CASE&quot;</span>, <span class="ident">ScreamingKebabCase</span>),
];

<span class="kw">impl</span> <span class="ident">RenameRule</span> {
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">from_str</span>(<span class="ident">rename_all_str</span>: <span class="kw-2">&amp;</span><span class="ident">str</span>) -&gt; <span class="prelude-ty">Result</span><span class="op">&lt;</span><span class="self">Self</span>, <span class="ident">ParseError</span><span class="op">&gt;</span> {
        <span class="kw">for</span> (<span class="ident">name</span>, <span class="ident">rule</span>) <span class="kw">in</span> <span class="ident">RENAME_RULES</span> {
            <span class="kw">if</span> <span class="ident">rename_all_str</span> <span class="op">==</span> <span class="kw-2">*</span><span class="ident">name</span> {
                <span class="kw">return</span> <span class="prelude-val">Ok</span>(<span class="kw-2">*</span><span class="ident">rule</span>);
            }
        }
        <span class="prelude-val">Err</span>(<span class="ident">ParseError</span> {
            <span class="ident">unknown</span>: <span class="ident">rename_all_str</span>,
        })
    }

    <span class="doccomment">/// Apply a renaming rule to an enum variant, returning the version expected in the source.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">apply_to_variant</span>(<span class="kw-2">&amp;</span><span class="self">self</span>, <span class="ident">variant</span>: <span class="kw-2">&amp;</span><span class="ident">str</span>) -&gt; <span class="ident">String</span> {
        <span class="kw">match</span> <span class="kw-2">*</span><span class="self">self</span> {
            <span class="prelude-val">None</span> <span class="op">|</span> <span class="ident">PascalCase</span> =&gt; <span class="ident">variant</span>.<span class="ident">to_owned</span>(),
            <span class="ident">LowerCase</span> =&gt; <span class="ident">variant</span>.<span class="ident">to_ascii_lowercase</span>(),
            <span class="ident">UpperCase</span> =&gt; <span class="ident">variant</span>.<span class="ident">to_ascii_uppercase</span>(),
            <span class="ident">CamelCase</span> =&gt; <span class="ident">variant</span>[..<span class="number">1</span>].<span class="ident">to_ascii_lowercase</span>() <span class="op">+</span> <span class="kw-2">&amp;</span><span class="ident">variant</span>[<span class="number">1</span>..],
            <span class="ident">SnakeCase</span> =&gt; {
                <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">snake</span> <span class="op">=</span> <span class="ident">String::new</span>();
                <span class="kw">for</span> (<span class="ident">i</span>, <span class="ident">ch</span>) <span class="kw">in</span> <span class="ident">variant</span>.<span class="ident">char_indices</span>() {
                    <span class="kw">if</span> <span class="ident">i</span> <span class="op">&gt;</span> <span class="number">0</span> <span class="op">&amp;&amp;</span> <span class="ident">ch</span>.<span class="ident">is_uppercase</span>() {
                        <span class="ident">snake</span>.<span class="ident">push</span>(<span class="string">&#39;_&#39;</span>);
                    }
                    <span class="ident">snake</span>.<span class="ident">push</span>(<span class="ident">ch</span>.<span class="ident">to_ascii_lowercase</span>());
                }
                <span class="ident">snake</span>
            }
            <span class="ident">ScreamingSnakeCase</span> =&gt; <span class="ident">SnakeCase</span>.<span class="ident">apply_to_variant</span>(<span class="ident">variant</span>).<span class="ident">to_ascii_uppercase</span>(),
            <span class="ident">KebabCase</span> =&gt; <span class="ident">SnakeCase</span>.<span class="ident">apply_to_variant</span>(<span class="ident">variant</span>).<span class="ident">replace</span>(<span class="string">&#39;_&#39;</span>, <span class="string">&quot;-&quot;</span>),
            <span class="ident">ScreamingKebabCase</span> =&gt; <span class="ident">ScreamingSnakeCase</span>
                .<span class="ident">apply_to_variant</span>(<span class="ident">variant</span>)
                .<span class="ident">replace</span>(<span class="string">&#39;_&#39;</span>, <span class="string">&quot;-&quot;</span>),
        }
    }

    <span class="doccomment">/// Apply a renaming rule to a struct field, returning the version expected in the source.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">apply_to_field</span>(<span class="kw-2">&amp;</span><span class="self">self</span>, <span class="ident">field</span>: <span class="kw-2">&amp;</span><span class="ident">str</span>) -&gt; <span class="ident">String</span> {
        <span class="kw">match</span> <span class="kw-2">*</span><span class="self">self</span> {
            <span class="prelude-val">None</span> <span class="op">|</span> <span class="ident">LowerCase</span> <span class="op">|</span> <span class="ident">SnakeCase</span> =&gt; <span class="ident">field</span>.<span class="ident">to_owned</span>(),
            <span class="ident">UpperCase</span> =&gt; <span class="ident">field</span>.<span class="ident">to_ascii_uppercase</span>(),
            <span class="ident">PascalCase</span> =&gt; {
                <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">pascal</span> <span class="op">=</span> <span class="ident">String::new</span>();
                <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">capitalize</span> <span class="op">=</span> <span class="bool-val">true</span>;
                <span class="kw">for</span> <span class="ident">ch</span> <span class="kw">in</span> <span class="ident">field</span>.<span class="ident">chars</span>() {
                    <span class="kw">if</span> <span class="ident">ch</span> <span class="op">==</span> <span class="string">&#39;_&#39;</span> {
                        <span class="ident">capitalize</span> <span class="op">=</span> <span class="bool-val">true</span>;
                    } <span class="kw">else</span> <span class="kw">if</span> <span class="ident">capitalize</span> {
                        <span class="ident">pascal</span>.<span class="ident">push</span>(<span class="ident">ch</span>.<span class="ident">to_ascii_uppercase</span>());
                        <span class="ident">capitalize</span> <span class="op">=</span> <span class="bool-val">false</span>;
                    } <span class="kw">else</span> {
                        <span class="ident">pascal</span>.<span class="ident">push</span>(<span class="ident">ch</span>);
                    }
                }
                <span class="ident">pascal</span>
            }
            <span class="ident">CamelCase</span> =&gt; {
                <span class="kw">let</span> <span class="ident">pascal</span> <span class="op">=</span> <span class="ident">PascalCase</span>.<span class="ident">apply_to_field</span>(<span class="ident">field</span>);
                <span class="ident">pascal</span>[..<span class="number">1</span>].<span class="ident">to_ascii_lowercase</span>() <span class="op">+</span> <span class="kw-2">&amp;</span><span class="ident">pascal</span>[<span class="number">1</span>..]
            }
            <span class="ident">ScreamingSnakeCase</span> =&gt; <span class="ident">field</span>.<span class="ident">to_ascii_uppercase</span>(),
            <span class="ident">KebabCase</span> =&gt; <span class="ident">field</span>.<span class="ident">replace</span>(<span class="string">&#39;_&#39;</span>, <span class="string">&quot;-&quot;</span>),
            <span class="ident">ScreamingKebabCase</span> =&gt; <span class="ident">ScreamingSnakeCase</span>.<span class="ident">apply_to_field</span>(<span class="ident">field</span>).<span class="ident">replace</span>(<span class="string">&#39;_&#39;</span>, <span class="string">&quot;-&quot;</span>),
        }
    }
}

<span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">ParseError</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span><span class="op">&gt;</span> {
    <span class="ident">unknown</span>: <span class="kw-2">&amp;</span><span class="lifetime">&#39;a</span> <span class="ident">str</span>,
}

<span class="kw">impl</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span><span class="op">&gt;</span> <span class="ident">Display</span> <span class="kw">for</span> <span class="ident">ParseError</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span><span class="op">&gt;</span> {
    <span class="kw">fn</span> <span class="ident">fmt</span>(<span class="kw-2">&amp;</span><span class="self">self</span>, <span class="ident">f</span>: <span class="kw-2">&amp;mut</span> <span class="ident">fmt::Formatter</span>) -&gt; <span class="ident">fmt::Result</span> {
        <span class="ident">f</span>.<span class="ident">write_str</span>(<span class="string">&quot;unknown rename rule `rename_all = &quot;</span>)<span class="question-mark">?</span>;
        <span class="ident">Debug::fmt</span>(<span class="self">self</span>.<span class="ident">unknown</span>, <span class="ident">f</span>)<span class="question-mark">?</span>;
        <span class="ident">f</span>.<span class="ident">write_str</span>(<span class="string">&quot;`, expected one of &quot;</span>)<span class="question-mark">?</span>;
        <span class="kw">for</span> (<span class="ident">i</span>, (<span class="ident">name</span>, <span class="ident">_rule</span>)) <span class="kw">in</span> <span class="ident">RENAME_RULES</span>.<span class="ident">iter</span>().<span class="ident">enumerate</span>() {
            <span class="kw">if</span> <span class="ident">i</span> <span class="op">&gt;</span> <span class="number">0</span> {
                <span class="ident">f</span>.<span class="ident">write_str</span>(<span class="string">&quot;, &quot;</span>)<span class="question-mark">?</span>;
            }
            <span class="ident">Debug::fmt</span>(<span class="ident">name</span>, <span class="ident">f</span>)<span class="question-mark">?</span>;
        }
        <span class="prelude-val">Ok</span>(())
    }
}

<span class="attribute">#[<span class="ident">test</span>]</span>
<span class="kw">fn</span> <span class="ident">rename_variants</span>() {
    <span class="kw">for</span> <span class="kw-2">&amp;</span>(<span class="ident">original</span>, <span class="ident">lower</span>, <span class="ident">upper</span>, <span class="ident">camel</span>, <span class="ident">snake</span>, <span class="ident">screaming</span>, <span class="ident">kebab</span>, <span class="ident">screaming_kebab</span>) <span class="kw">in</span> <span class="kw-2">&amp;</span>[
        (
            <span class="string">&quot;Outcome&quot;</span>, <span class="string">&quot;outcome&quot;</span>, <span class="string">&quot;OUTCOME&quot;</span>, <span class="string">&quot;outcome&quot;</span>, <span class="string">&quot;outcome&quot;</span>, <span class="string">&quot;OUTCOME&quot;</span>, <span class="string">&quot;outcome&quot;</span>, <span class="string">&quot;OUTCOME&quot;</span>,
        ),
        (
            <span class="string">&quot;VeryTasty&quot;</span>,
            <span class="string">&quot;verytasty&quot;</span>,
            <span class="string">&quot;VERYTASTY&quot;</span>,
            <span class="string">&quot;veryTasty&quot;</span>,
            <span class="string">&quot;very_tasty&quot;</span>,
            <span class="string">&quot;VERY_TASTY&quot;</span>,
            <span class="string">&quot;very-tasty&quot;</span>,
            <span class="string">&quot;VERY-TASTY&quot;</span>,
        ),
        (<span class="string">&quot;A&quot;</span>, <span class="string">&quot;a&quot;</span>, <span class="string">&quot;A&quot;</span>, <span class="string">&quot;a&quot;</span>, <span class="string">&quot;a&quot;</span>, <span class="string">&quot;A&quot;</span>, <span class="string">&quot;a&quot;</span>, <span class="string">&quot;A&quot;</span>),
        (<span class="string">&quot;Z42&quot;</span>, <span class="string">&quot;z42&quot;</span>, <span class="string">&quot;Z42&quot;</span>, <span class="string">&quot;z42&quot;</span>, <span class="string">&quot;z42&quot;</span>, <span class="string">&quot;Z42&quot;</span>, <span class="string">&quot;z42&quot;</span>, <span class="string">&quot;Z42&quot;</span>),
    ] {
        <span class="macro">assert_eq!</span>(<span class="prelude-val">None</span>.<span class="ident">apply_to_variant</span>(<span class="ident">original</span>), <span class="ident">original</span>);
        <span class="macro">assert_eq!</span>(<span class="ident">LowerCase</span>.<span class="ident">apply_to_variant</span>(<span class="ident">original</span>), <span class="ident">lower</span>);
        <span class="macro">assert_eq!</span>(<span class="ident">UpperCase</span>.<span class="ident">apply_to_variant</span>(<span class="ident">original</span>), <span class="ident">upper</span>);
        <span class="macro">assert_eq!</span>(<span class="ident">PascalCase</span>.<span class="ident">apply_to_variant</span>(<span class="ident">original</span>), <span class="ident">original</span>);
        <span class="macro">assert_eq!</span>(<span class="ident">CamelCase</span>.<span class="ident">apply_to_variant</span>(<span class="ident">original</span>), <span class="ident">camel</span>);
        <span class="macro">assert_eq!</span>(<span class="ident">SnakeCase</span>.<span class="ident">apply_to_variant</span>(<span class="ident">original</span>), <span class="ident">snake</span>);
        <span class="macro">assert_eq!</span>(<span class="ident">ScreamingSnakeCase</span>.<span class="ident">apply_to_variant</span>(<span class="ident">original</span>), <span class="ident">screaming</span>);
        <span class="macro">assert_eq!</span>(<span class="ident">KebabCase</span>.<span class="ident">apply_to_variant</span>(<span class="ident">original</span>), <span class="ident">kebab</span>);
        <span class="macro">assert_eq!</span>(
            <span class="ident">ScreamingKebabCase</span>.<span class="ident">apply_to_variant</span>(<span class="ident">original</span>),
            <span class="ident">screaming_kebab</span>
        );
    }
}

<span class="attribute">#[<span class="ident">test</span>]</span>
<span class="kw">fn</span> <span class="ident">rename_fields</span>() {
    <span class="kw">for</span> <span class="kw-2">&amp;</span>(<span class="ident">original</span>, <span class="ident">upper</span>, <span class="ident">pascal</span>, <span class="ident">camel</span>, <span class="ident">screaming</span>, <span class="ident">kebab</span>, <span class="ident">screaming_kebab</span>) <span class="kw">in</span> <span class="kw-2">&amp;</span>[
        (
            <span class="string">&quot;outcome&quot;</span>, <span class="string">&quot;OUTCOME&quot;</span>, <span class="string">&quot;Outcome&quot;</span>, <span class="string">&quot;outcome&quot;</span>, <span class="string">&quot;OUTCOME&quot;</span>, <span class="string">&quot;outcome&quot;</span>, <span class="string">&quot;OUTCOME&quot;</span>,
        ),
        (
            <span class="string">&quot;very_tasty&quot;</span>,
            <span class="string">&quot;VERY_TASTY&quot;</span>,
            <span class="string">&quot;VeryTasty&quot;</span>,
            <span class="string">&quot;veryTasty&quot;</span>,
            <span class="string">&quot;VERY_TASTY&quot;</span>,
            <span class="string">&quot;very-tasty&quot;</span>,
            <span class="string">&quot;VERY-TASTY&quot;</span>,
        ),
        (<span class="string">&quot;a&quot;</span>, <span class="string">&quot;A&quot;</span>, <span class="string">&quot;A&quot;</span>, <span class="string">&quot;a&quot;</span>, <span class="string">&quot;A&quot;</span>, <span class="string">&quot;a&quot;</span>, <span class="string">&quot;A&quot;</span>),
        (<span class="string">&quot;z42&quot;</span>, <span class="string">&quot;Z42&quot;</span>, <span class="string">&quot;Z42&quot;</span>, <span class="string">&quot;z42&quot;</span>, <span class="string">&quot;Z42&quot;</span>, <span class="string">&quot;z42&quot;</span>, <span class="string">&quot;Z42&quot;</span>),
    ] {
        <span class="macro">assert_eq!</span>(<span class="prelude-val">None</span>.<span class="ident">apply_to_field</span>(<span class="ident">original</span>), <span class="ident">original</span>);
        <span class="macro">assert_eq!</span>(<span class="ident">UpperCase</span>.<span class="ident">apply_to_field</span>(<span class="ident">original</span>), <span class="ident">upper</span>);
        <span class="macro">assert_eq!</span>(<span class="ident">PascalCase</span>.<span class="ident">apply_to_field</span>(<span class="ident">original</span>), <span class="ident">pascal</span>);
        <span class="macro">assert_eq!</span>(<span class="ident">CamelCase</span>.<span class="ident">apply_to_field</span>(<span class="ident">original</span>), <span class="ident">camel</span>);
        <span class="macro">assert_eq!</span>(<span class="ident">SnakeCase</span>.<span class="ident">apply_to_field</span>(<span class="ident">original</span>), <span class="ident">original</span>);
        <span class="macro">assert_eq!</span>(<span class="ident">ScreamingSnakeCase</span>.<span class="ident">apply_to_field</span>(<span class="ident">original</span>), <span class="ident">screaming</span>);
        <span class="macro">assert_eq!</span>(<span class="ident">KebabCase</span>.<span class="ident">apply_to_field</span>(<span class="ident">original</span>), <span class="ident">kebab</span>);
        <span class="macro">assert_eq!</span>(<span class="ident">ScreamingKebabCase</span>.<span class="ident">apply_to_field</span>(<span class="ident">original</span>), <span class="ident">screaming_kebab</span>);
    }
}
</code></pre></div>
</section></div></main><div id="rustdoc-vars" data-root-path="../../../" data-current-crate="serde_derive" data-themes="ayu,dark,light" data-resource-suffix="" data-rustdoc-version="1.64.0-dev" ></div>
</body></html>